function bags = buildSubspaces(dims, numBags, bagtype)
        
btype = bagtype(1:3);
bval = str2num(bagtype(4:end));
if strcmp(btype, 'fix') && ~isa(bval,'double')
	error('The string "bagtype" does not seem correct.');
end


oldSeed = rand('seed'); %Remember previous seed
rand('seed', 1);     %Set seed for this operation

bags = cell(numBags,1);


switch btype
    case {'var'}    %Fixed number of features, with replacement
        
        a=0.25;
        b=0.75;
        
        for i=1:numBags
            numFeat = a + (b-a).*rand(1,1);
            numFeat = round(numFeat*dims);
                        
            rp=randperm(dims);
            
            
            newBag=rp(1:numFeat);
            bags{i} = newBag;
        end    
    
    
    case {'fix'}    %Fixed number of features, with replacement
        

        if(bval>1)                          %Bag value is number of features
            numFeatures = bval;
            if bval>dims
                error('Subspace dimensionality may not exceed the total dimensionality');
            end
        else                                %Bag value is fraction of features
            numFeatures = round(bval*dims);
        end
        
        for i=1:numBags
            rp=randperm(dims);
            newBag=rp(1:numFeatures);
            bags{i} = newBag;
        end    
        
    otherwise
        error('Bag type unrecognized');
end

rand('seed',oldSeed);   %Reset seed