function [Dbag Dmiles] = create_Dmatrices(datanr, scaleFlag);


%Load the MIL dataset. This requires to have the raw data
%         if (datanr >= 155 && datanr <= 163)
%             [x z] = reallifemil(datanr);
%             a = [x; z];
%         else
%             a = reallifemil(datanr);
%         end
%
warning('Loading Musk1, please download other datasets from miproblems.org');
prload('musk1.mat');
a=x; clear x;

%Scale features if necessary
if (nargin == 2 && scaleFlag == 1)
    a = a*scalem(a,'variance');
end

[bags labs ids bagids] = getbags(a);
N = length(labs);

%Create representations
Dbag = nan(N,N);
Dmiles = nan(N,size(a,1));


for i=1:N
    i
    tic;
    bagI = bags{i};
    
    startix=1;
    for j=1:N
        
        bagJ = bags{j};
        
        %Instance distances between two bags
        d=sqeucldistm(bagI,bagJ);
        d1 = min(d,[],1);
        
        Dmiles(i, startix:(startix+length(d1)-1)) = d1;
        startix=startix+length(d1);
        
        Dbag(i,j) = mean(d1);
    end
    toc
end

Dbag = prdataset(Dbag,labs);
Dmiles = prdataset(Dmiles,labs);

save(['D_bag_miles_'  num2str(datanr) '.mat'], 'Dbag', 'Dmiles');


