function resultsComparison(datanrs)


numComparedClasf = 11;
folds = 10;

allres = nan(numComparedClasf, length(datanrs), folds);




for dd=1:length(datanrs)

    %Load results of classifiers used in comparison (by David Tax)
    load(['comparison_' num2str(datanrs(dd)) '.mat'], 'T');  %[9x5x10] [classifier,shuffle,folds]
    
    whichShuffle = 1; %I only did 1x10-fold, so use results from 1st shuffle of 10 folds to compare
    
    
   %Put results together into the same matrix
   if(size(T.res,1) == 9)  
      allres(1:8, dd, :) = T.res(2:9,1,:); 
   else
      allres(1:8, dd, :) = T.res(:,1,:);  
   end
    
   
   load(['res_r1_final_primsvc_' num2str(datanrs(dd)) '.mat']); 
   allres(9,dd,:) = err(1,:);
   allres(10,dd,:) = err(2,:);
   allres(11,dd,:) = err(3,:);
  
end

%% 
clasfnames = {'EM-DD', 'MI-SVM p=1', 'MI-SVM r=10', 'MILBoost',  'MILES p=1', 'MILES r=10', 'minimax+log', 'minimax+SVM', 'Dbag', 'Dinst', 'DRS'}

%Which classifiers to dispay (Table 4 in TNNLS)
whichclasf = [1 3 4 6 8 11];

allres = permute(allres, [2 1 3]);
allres = 1 - allres; %Display accuracy instead of error


%%
R = results(allres(:,whichclasf,:),datanrs,clasfnames(whichclasf),[1:10]);
R = setdimname(R,'Dataset','Classifier','run');
R = setname(R, 'Comparison');
    
fprintf('\n%s\n\n',repmat('=',1,50));
S = average(100*R,3,'max2','dep', 'use_ste');
show(S,'latex','%3.1f');





