function resultsDiversity(datanr)

%% Load results of a dataset



load(['res_mcs2013_diversity_' num2str(datanr) '.mat']);


%% Compute diversity measure on those results. Here we are interested in differences between two groups of classifiers (bag and rand)
d = diversityMatrix([bagres;randres], {'disagree'});
labs = [repmat('bag   ',length(bagres),1); repmat('random',length(randres),1)]; 


divdata = prdataset(d,labs);


%Make 2D embedding of the distances
figure(1);m=mds(divdata); 

save(['res_diversity_' num2str(datanr) '.mat'], 'divdata','m');

%% Get the classifier distances and make a nice figure


load(['res_diversity_' num2str(datanr) '.mat'], 'divdata','m');


divdata = divdata*m;



close all;
figure(1);

c1 = seldat(divdata,1);
c2 = seldat(divdata,2);

hold on;
s1=scatterd(c1, 'o');  set(s1, 'Color', [0 0.5 0.75]); set(s1, 'LineWidth', 1.5);  hold on;
s2=scatterd(c2, 'x'); set(s2, 'Color', [0.5 0.5 0]); set(s2, 'LineWidth', 1.5); set(s2, 'MarkerSize', 8);

l=legend({'bag','random'});
set(l,'interpreter','latex');
set(l,'FontSize',16);

t = title(['Classifier Projection Space, ' num2str(datanr) ', SVM']);
set(t,'interpreter','latex');
set(t,'FontSize',16);


set(gcf,'Color',[1 1 1])
set(gca,'Color',[1 1 1])
set(gcf, 'InvertHardCopy', 'off');

axis off;


%h=gca;
%saveas(h, ['..\figures\cps_primsvc_' num2str(datanr) '.fig']);
%export_fig(['../figures/cps_primsvc_' num2str(datanr) '.pdf']);

