function resultsHistograms(datanr, cname)


strTitle = [num2str(datanr) ', ' cname];

fname=[cname '_' num2str(datanr)];
load(['res_mcs2013_' fname '.mat']);

clf;
err10=mean(err(:,1:10),2);
bs = err10(3);
rs=err10(4);

mbs = mymean(errbs(:,1:10),2);
mrs = mymean(errrs(:,1:10),2);

[h1,x1] = hist(mbs);
[h2,x2] = hist(mrs,x1);

figure(2);
hist(mbs);
hold on;
hist(mrs); 
set(0,'defaulttextinterpreter','latex')
h=findobj(gca,'Type','patch');
set(h(1),'FaceColor',[0.5 0.5 0],'EdgeColor','k');
set(h(2),'FaceColor',[0.4 0.7 1],'EdgeColor','k');

h=gca;
ylim=get(h, 'YLim')


set(gcf,'Color',[1 1 1])
set(gca,'Color',[1 1 1])
set(gcf, 'InvertHardCopy', 'off');

plot([bs bs], ylim,'Color',[0 0.35 0.6], 'LineWidth', 3, 'LineStyle', '-.', 'Marker', 'o');
plot([rs rs], ylim, 'Color',[0.35 0.35 0], 'LineWidth',3,'LineStyle', '--', 'Marker', 'o');

set(gca,'FontName','Georgia','FontSize',14);


title(strTitle,'FontSize', 16);
l=legend('bag', 'random', '$D^{BS}$','$D^{RS}$');
set(l,'interpreter','latex');
set(l,'Location', 'NorthWest');
set(l,'FontSize',16);

xlabel('Area under ROC curve','FontSize',16);
ylabel('Number of base classifiers','FontSize',16);

set(h, 'YLim', ylim)

%h=gca;
%saveas(h, ['..\figures\hist_' fname, 'fig']);
%export_fig(['../figures/hist_' fname '.pdf']);



%%













