function resultsIndSizeScatter(datanr, cname)


fname=[cname '_' num2str(datanr)];

load(['res_mcs2013_' fname '.mat']);

%a = reallifemil(datanr);
warning('Loading Musk1, please download other datasets from miproblems.org');
prload('musk1.mat');
a=x; clear x;




[bags labs ids bagids] = getbags(a);
N=length(labs);
    
numinst = nan(N,1);
for i=1:N
    bagI = bags{i};
    numinst(i)=size(bagI,1);
end

close all;


err10folds = errbs(:,1:10);   % We did experiments with 50, but for experiments in journal paper only 10 folds
meanerr = mymean(err10folds,2);



figure(1);
posix = find(labs(:,1)=='p');
negix = find(labs(:,1)=='n');
scatter(numinst(posix), meanerr(posix),50, 'Marker', '+', 'MarkerEdgeColor', [0.75 0.25 0], 'LineWidth', 1.5);
hold on;
scatter(numinst(negix), meanerr(negix),50, 'Marker', 'o', 'MarkerEdgeColor', [0 0.25 0.75], 'LineWidth', 1.5);
l=legend('positive', 'negative');
xl=xlabel('Number of instances (subspace dimensionality)', 'FontSize', 14);
yl=ylabel('Average AUC', 'FontSize', 14);

ccoef = corr(numinst, meanerr);
t=title([num2str(datanr) ', ' cname '. Correlation ' sprintf('%1.2f', ccoef)], 'FontSize', 14);

set(gcf,'Color',[1 1 1])
set(gca,'Color',[1 1 1])
set(gcf, 'InvertHardCopy', 'off');
set(t,'Interpreter', 'latex');
set(xl,'Interpreter', 'latex');
set(yl,'Interpreter', 'latex');
set(l,'Interpreter', 'latex');

set(gca,'FontName','Georgia','FontSize',14);



%saveas(gcf,['../figures/scattersizebags_' fname '.fig']);
%export_fig(['../figures/scattersizebags_' fname '.pdf']);


