function resultsIndividualSize(datanr, clname)

%Parameters, indices, etc.
load(['train_randsubspace_extra_' clname '_' num2str(datanr) '.mat']);

%Classifier results
load(['res_randsub_' clname '_' num2str(datanr) '.mat']);


%Did not save this anywhere apparently:
ensembleSizes = [10 20 50 100]; 


%Compare ensembles to single classifier

%1 plot per combining rule
%x-axis: increase ensemble size, different plots = different feature sizes

close all

   
%%

avgErr = nanmean(errSub,1);      %100 classifiers per 5 subspace sizes
avgPerSize = nanmean(avgErr,3);  %average for each size
stdPerSize = nanstd(avgErr,[],3);


errSingle = mean(errSingleClasf(:,1));


%%
e1 = avgErr(:,1,:);
e2 = avgErr(:,2,:);
e3 = avgErr(:,3,:);
e4 = avgErr(:,4,:);
e5 = avgErr(:,5,:);

%All features in the last box in the boxplot
e6 = repmat(errSingle, size(e5));

figure(1);
hold on; 

b = boxplot([e1(:) e2(:) e3(:) e4(:) e5(:) e6(:)], [subspaceSizes 150], 'colors', 'k');

set(findobj(gca,'Type','text'),'FontSize',12);
set(findobj(gca,'Type','text'),'FontName','Georgia');


t=title([num2str(datanr) ', ' clname], 'FontSize',18,'Color', [0 0 0]);

set(t, 'Interpreter', 'latex');



set(gca,'xtick',[1 2 3 4 5 6]);
set(gca,'XTickLabel',{'5', '10', '25', '50', '100', 'All'})

set(gca,'FontName','Georgia','FontSize',12);



xlab=xlabel('Features per subspace','FontSize',12,'Color', [0 0 0]);




ylab=ylabel('AUC','FontSize',12,'Color', [0 0 0]);

set(gcf,'Color',[1 1 1])
set(gca,'Color',[1 1 1])
set(gcf, 'InvertHardCopy', 'off');


set(xlab,'Position', get(xlab,'Position')-[0 10 0])  



%saveas(gcf,['../figures/' fname '.tif']);
%fname = ['scattersize_r1_' num2str(datanr) '_' clname];
%saveas(gcf,['../figures/' fname '.fig']);
%export_fig(['../figures/' fname '.pdf']);

