function resultsSubspaceClassifiers(datanr, clname)



clfullname = clname;


%Evaluation

%Parameters, indices, etc.
load(['train_randsubspace_extra_' clname '_' num2str(datanr) '.mat']);

%Classifier results
load(['res_randsub_' clname '_' num2str(datanr) '.mat']);


%Did not save this anywhere apparently:
ensembleSizes = [10 20 50 100]; 



%Compare ensembles to single classifier

%1 plot per combining rule
%x-axis: increase ensemble size, different plots = different feature sizes

close all

figure(1);
hold on;    
e1 = nanmean(errSingleClasf(:,1,:));
plot(ensembleSizes, repmat(e1, 1, length(ensembleSizes)),  'LineWidth',1.5, 'Color', [0 0 0]);


m1 = nanmean(errCombMean(:,1,:),1);
plot(ensembleSizes, m1(:), 'LineWidth',1.5, 'Color', [0 0.5 0.9] , 'Marker', '+', 'MarkerSize', 9 );

m2 = nanmean(errCombMean(:,2,:),1);
plot(ensembleSizes, m2(:), 'LineWidth',1.5, 'Color', [1 0.75 0]  , 'Marker', 'o', 'MarkerSize', 9 );

m3 = nanmean(errCombMean(:,3,:),1);
plot(ensembleSizes, m3(:), 'LineWidth',1.5, 'Color',[0.5 0.75 0], 'Marker', 'x', 'MarkerSize', 9 );

m4 = nanmean(errCombMean(:,4,:),1);
plot(ensembleSizes, m4(:), 'LineWidth',1.5, 'Color',  [0.9 0 0.25], 'Marker', 's', 'MarkerSize', 9);

m5 = nanmean(errCombMean(:,5,:),1);
plot(ensembleSizes, m5(:), 'LineWidth',1.5, 'Color', [0.5 0 0.5], 'Marker', 'd', 'MarkerSize', 9);

t=title([num2str(datanr) ', ' clfullname ', mean'], 'FontSize',18,'Color', [0 0 0]);
l=legend({'all', '5', '10', '25', '50', '100'}, 'Location', 'SouthEast');

set(gcf,'Color',[1 1 1])
set(gca,'Color',[1 1 1])
set(gcf, 'InvertHardCopy', 'off');
set(l,'FontSize', 16);
set(l,'TextColor', [0 0 0]);
set(l,'Interpreter', 'latex');
set(t,'Interpreter', 'latex');

set(gca,'FontName','Georgia','FontSize',14);
xlab=xlabel('Classifiers in ensemble','FontSize',16,'Color', [0 0 0]);
ylab=ylabel('Area under ROC curve','FontSize',16,'Color', [0 0 0]);


%fname = ['parplot_' num2str(datanr) '_' clname '_mean'];
%saveas(gcf,['../figures/' fname '.fig']);
%export_fig(['../figures/' fname '.pdf']);





figure(2);
hold on;    
e1 = nanmean(errSingleClasf(:,1,:));
plot(ensembleSizes, repmat(e1, 1, length(ensembleSizes)), '-.k');


m1 = nanmean(errCombVote(:,1,:),1);
plot(ensembleSizes, m1(:), 'LineWidth',1.5, 'Color', [0 0.5 0.9] , 'Marker', '+', 'MarkerSize', 9 );

m2 = nanmean(errCombVote(:,2,:),1);
plot(ensembleSizes, m2(:), 'LineWidth',1.5, 'Color', [1 0.75 0]  , 'Marker', 'o', 'MarkerSize', 9 );

m3 = nanmean(errCombVote(:,3,:),1);
plot(ensembleSizes, m3(:), 'LineWidth',1.5, 'Color',[0.5 0.75 0], 'Marker', 'x', 'MarkerSize', 9 );

m4 = nanmean(errCombVote(:,4,:),1);
plot(ensembleSizes, m4(:), 'LineWidth',1.5, 'Color',  [0.9 0 0.25], 'Marker', 's', 'MarkerSize', 9);

m5 = nanmean(errCombVote(:,5,:),1);
plot(ensembleSizes, m5(:), 'LineWidth',1.5, 'Color', [0.5 0 0.5], 'Marker', 'd', 'MarkerSize', 9);

t=title([num2str(datanr) ', ' clfullname ', vote'], 'FontSize',18,'Color', [0 0 0]);

l=legend({'all', '5', '10', '25', '50', '100'}, 'Location', 'SouthEast');



set(gcf,'Color',[1 1 1])
set(gca,'Color',[1 1 1])
set(gcf, 'InvertHardCopy', 'off');
set(l,'FontSize', 16);
set(l,'TextColor', [0 0 0]);
set(l,'Interpreter', 'latex');
set(t,'Interpreter', 'latex');

set(gca,'FontName','Georgia','FontSize',14);
xlab=xlabel('Classifiers in ensemble','FontSize',16,'Color', [0 0 0]);
ylab=ylabel('Area under ROC curve','FontSize',16,'Color', [0 0 0]);


%fname = ['parplot_' num2str(datanr) '_' clname '_vote'];
%saveas(gcf,['../figures/' fname '.fig']);
%export_fig(['../figures/' fname '.pdf']);

