load('learncurve_libsvc.mat');


mmean = mean(err,3);
mstd = std(err,[],3);
nbags = [5 10 20 40];

close all;
figure;
hold on;
set(0,'defaulttextinterpreter','latex')


%axis([0,50,0.5,0.9])
%set(gca,'YTick',[0.5:0.1:0.9])

set(gcf,'Color',[1 1 1])
set(gca,'Color',[1 1 1])
set(gcf, 'InvertHardCopy', 'off');

plot(nbags,mmean(1,:),'LineWidth',1.5, 'Color', [0.75 0.25 0], 'Marker', '+', 'MarkerSize', 9);
plot(nbags,mmean(2,:),'LineWidth',1.5, 'Color', [0.5 0 0.5], 'Marker', 'o','MarkerSize', 9);
plot(nbags,mmean(3,:),'LineWidth',1.5, 'Color', [0 0.5 0.75], 'Marker', 'x','MarkerSize', 9);
plot(nbags,mmean(4,:),'LineWidth',1.5, 'Color', [0.5 0.5 0], 'Marker', 's','MarkerSize', 9);

l=legend('$D^{bag}$', '$D^{inst}$', '$D^{BS}$', '$D^{RS}$', 'Location', 'SouthEast');
%l=legend('$D^{bag}$', '$D^{inst}$', 'Location', 'SouthEast');
set(l,'FontSize', 20);
set(l,'TextColor', [0 0 0]);
set(l,'Interpreter', 'latex');
t=title('Artificial dataset, SVM','FontSize',16,'Color', [0 0 0]);

set(gca,'FontName','Georgia','FontSize',14);
xlab=xlabel('Training bags per class','FontSize',16,'Color', [0 0 0]);
ylab=ylabel('Area under ROC curve','FontSize',16,'Color', [0 0 0]);


saveas(gcf,['../figures/learncurve_libsvc.fig']);
export_fig('../figures/learncurve_libsvc.pdf');
%set(gcf,'paperunits','centimeters')
%set(gcf,'papersize',[12,9])
%set(gcf,'paperposition',[0,0,12,9])
%print('-dpdf', ['paper\learncurve_gauss.pdf']);

%%


