%% Example code for the papers

% Cheplygina, V., Tax, D. M., & Loog, M. (2016). 
% Dissimilarity-based ensembles for multiple instance learning. 
% IEEE transactions on neural networks and learning systems, 27(6), 1379-1391.
% 
% and
%
% Cheplygina, V., Tax, D. M. J., & Loog, M. (2013). 
% Combining instance information to classify bags. 
% In International Workshop on Multiple Classifier Systems (pp. 13-24). 

%% Do experiments with several MIL datasets

%Datasets used in the paper, see reallifemil.m which datasets these correspond to 
%Datasets are available for download from miproblems.org
%datanrs = [101 102 301 302 303 164 316 317 110 111 314]; 


datanrs = [101]; %For this example, only using the Musk1 dataset

for i=1:length(datanrs)
    
    %Compute the representations 
    dataScaling = 1; 
    create_Dmatrices(datanrs(i),dataScaling);

    %Preliminary experiments in MCS 2013 paper (needed for
    %resultsDiversity and resultsIndSizeScatter)
    run_mcs2013_exp(datanrs(i), primsvc, 'primsvc');
   
    %Train and test subspace classifiers
    trainSubspaceClassifiers(datanrs(i), primsvc, 'primsvc');
    testSubspaceClassifiers(datanrs(i), 'primsvc');
    
    %Test final ensemble and save weights (needed for resultsFeatureSelection)    
    saveWeights=1;
    testFinalEnsemble(datanrs(i), primsvc,'primsvc', saveWeights);
    
    %Show some results
    
    resultsHistograms(datanrs(i), 'primsvc');          %Fig.2 in TNNLS
    resultsIndSizeScatter(datanrs(i), 'primsvc');      %Fig.3 in TNNLS
    resultsIndividualSize(datanrs(i), 'primsvc');      %Fig.4 in TNNLS
    resultsDiversity(datanrs(i));                      %Fig.5 in TNNLS   
    resultsSubspaceClassifiers(datanrs(i), 'primsvc'); %Fig.7 in TNNLS
    resultsFeatureSelection(datanrs(i), 'primsvc');    %Fig.8 in TNNLS
    
end

resultsComparison(datanrs) %Table 4 in TNNLS


%%


 





%%



