function run_mcs2013_exp(datanr, clasf, clname)




%a = reallifemil(datanr);
warning('Loading Musk1, please download other datasets from miproblems.org');
prload('musk1.mat');
a=x; clear x;




[bags labs ids bagids] = getbags(a);
N = length(labs);


Dfname = ['D_bag_miles_' num2str(datanr) '.mat'];
if(exist(Dfname, 'file'))
    load(Dfname);
else
    [Dbag Dmiles] = create_Dmatrices(datanr,1);
    
end

Dbag = prdataset(+Dbag, labs);
Dmiles = prdataset(+Dmiles, labs);
Dbag=setprior(Dbag, 0);
Dmiles = setprior(Dmiles,0);


shuffles=1;
folds=10;


err=nan(4,shuffles*folds);
errbs = nan(N, shuffles*folds);
errrs = nan(N, shuffles*folds);



%Random subspace parameters
meaninst = round(size(a,1)/N); %Average number of instances per bag
rsinst = ['fix' num2str(meaninst)];


newerr=nan(size(errbs));
newerr2 = nan(size(errrs));

for j=1:shuffles
    
     
    shuffleddata = milrandomize(a,j);

             
    I=folds;
    for jj=1:folds
        tic
        index=(j-1)*folds+jj
        
    
        
        [x,z,I, itr, ite] = milcrossval(shuffleddata,I); 
        
        %Find indices of the BAGS used (not instances)
        [trl trids] = getbaglabs(x);
        if(ischar(trids)), trids = cellstr(trids); end
        [trids1 bagixtr] = intersect(ids, trids); 
        
        [tel teids] = getbaglabs(z);
         if(ischar(teids)), teids = cellstr(teids); end
        [teids1 bagixte] = intersect(ids, teids); 
        
        xbag = Dbag(bagixtr, bagixtr);
        zbag = Dbag(bagixte, bagixtr);
         
        xmiles = Dmiles(bagixtr,itr);
        zmiles = Dmiles(bagixte,itr);
             
        trbag=scalem([],'variance')*clasf;
        trmiles=scalem([],'variance')*clasf;
        trbag = xbag*trbag;
        trmiles=xmiles*trmiles;
        
        dims=size(xmiles,2);
        bagsubspaces = bagids(bagixtr);
        subspaces  = buildSubspaces(dims, length(bagixtr), rsinst);
                
        %Variables to store classifier evaluations for 1 fold (for
        %diversity)
        bagres = cell(length(subspaces),1);
        randres = cell(length(subspaces),1);
        
        
        trbags1 = cell(length(bagsubspaces),1);
        inststart=1;
        
        for k=1:length(bagsubspaces)
            instend = inststart+length(bagsubspaces{k})-1;
            uclasf1=scalem([],'variance')*featsel(dims,inststart:instend)*clasf;
            trbags1{k} = xmiles*uclasf1;
            
            res1=zmiles*trbags1{k};
            errbs(k,index) = dd_auc(res1*milroc);
                        
            inststart = inststart+length(bagsubspaces{k});
            
                 
            if(index == 1)
                bagres{k} = res1;
            end
        end
        
        
        %Train the bags
        trbags2 = cell(length(subspaces),1);
        for k=1:length(subspaces)
            uclasf2=scalem([],'variance')*featsel(dims,subspaces{k})*clasf;
            trbags2{k} = xmiles*uclasf2;
            
            res2=zmiles*trbags2{k};
            errrs(k,index) = dd_auc(res2*milroc);
            
            if(index == 1)
                randres{k} = res2;
            end
        end
     
        
   
        
        
        %Combined classifiers
        w1 = [trbags1{1}];
        w2 = [trbags2{1}];
        
        for k=2:length(bagsubspaces)
            w1 = [w1 trbags1{k}];
        end
                
        for k=2:length(subspaces)
            w2 = [w2 trbags2{k}];
        end
                
        trw1 = w1*meanc;
        trw2 = w2*meanc;
                
        tebag=zbag*trbag;
        temiles=zmiles*trmiles;
        tew1=zmiles*trw1;
        tew2=zmiles*trw2;
        
        
        err(1,index)=dd_auc(tebag*milroc);
        err(2,index)=dd_auc(temiles*milroc);
        err(3,index)=dd_auc(tew1*milroc);
        err(4,index)=dd_auc(tew2*milroc);
        
        
        e = errbs(:,index);
        ii = find(~isnan(e));
        
        e2 = errrs(:,index);
        ii2 = find(~isnan(e2));
        
        newerr(bagixtr, index) = e(ii);
        newerr2(bagixtr, index) = e2(ii2);
        
        toc
        
        if(index == 1)
           save(['res_mcs2013_diversity_' num2str(datanr) '.mat'], 'randres', 'bagres'); 
        end
        
        
    end
end    

errbs=newerr;
errrs=newerr2;
   
disp(a.name);
mean(err,2)

save(['res_mcs2013_' clname '_' num2str(datanr) '.mat'], 'err', 'clasf', 'errbs', 'errrs');

end

