function testFinalEnsemble(datanr, clasf, clname, saveWeights)




shuffles=1;
folds=10;

numClasf = 100;



%a = reallifemil(datanr);
warning('Loading Musk1, please download other datasets from miproblems.org');
prload('musk1.mat');
a=x; clear x;



[bags labs ids bagids] = getbags(a);
N = length(labs);


Dfname = ['D_bag_miles_' num2str(datanr) '.mat'];
if(exist(Dfname, 'file'))
    prload(Dfname);
else
    [Dbag Dmiles] = create_Dmatrices(datanr,1);
    
end


Dbag = prdataset(+Dbag, labs);
Dmiles = prdataset(+Dmiles, labs);
Dbag=setprior(Dbag, 0);
Dmiles = setprior(Dmiles,0);


aucperf=nan(3,shuffles*folds);
err=nan(3,shuffles*folds);

resBag = cell(shuffles*folds);
resInst = cell(shuffles*folds);
resRS = cell(shuffles*folds);
trainTimes = nan(3,shuffles*folds);
testTimes = nan(3,shuffles*folds);

for j=1:shuffles
    
    
    shuffleddata = milrandomize(a,j);
    
    
    I=folds;
    for jj=1:folds
        tic
        index=(j-1)*folds+jj
        
        
        
        [x,z,I, itr, ite] = milcrossval(shuffleddata,I);
        
        %Find indices of the BAGS used (not instances)
        [~, trids] = getbaglabs(x);
        if(ischar(trids)), trids = cellstr(trids); end
        [~, bagixtr] = intersect(ids, trids);
        
        [~, teids] = getbaglabs(z);
        if(ischar(teids)), teids = cellstr(teids); end
        [~, bagixte] = intersect(ids, teids);
        
        xbag = Dbag(bagixtr, bagixtr);
        zbag = Dbag(bagixte, bagixtr);
        
        
        xmiles = Dmiles(bagixtr,itr);
        zmiles = Dmiles(bagixte,itr);
        
        trbag=scalem([],'variance')*clasf;
        trmiles=scalem([],'variance')*clasf;
        
        
        tic; trbag = xbag*trbag; trainTimes(1,index) = toc;
        tic; trmiles=xmiles*trmiles; trainTimes(2,index) = toc;
        
        dims=size(xmiles,2);
        subspaces  = buildSubspaces(dims, numClasf, ['fix' num2str(round(dims/5))]);
        

        if (saveWeights == 1)
                clweights = nan(10,size(Dmiles,2)); 
        end
        
        %Train the subspaces
        tic;
        trbags2 = cell(length(subspaces),1);
        for k=1:length(subspaces)
            uclasf2=featsel(dims,subspaces{k})*scalem([],'variance')*clasf;
            trbags2{k} = xmiles*uclasf2;
            
             if (saveWeights == 1)
                
            %itr are indices of instances in the training set    
            %subspaces{k} are indices of subspace, but relative to current training set    
            %itr(subspaces{k}) are absolute indices of instances in subspace  
                
            cl=trbags2{k}.data;         
            %keyboard
            clweights(k,itr(subspaces{k})) = cl{2}.data.rot(:,1); %This is where the weights are stored
           
            
            
            end
            
            
        end
        
        
        if(saveWeights==1)
            
            save(['clweights_' num2str(datanr) '_' clname '.mat'], 'clweights');
        end
        
        
        %Combined classifiers
        w2 = [trbags2{1}];
        
        for k=2:length(subspaces)
            w2 = [w2 trbags2{k}];
        end
        
        
        trw2 = w2*meanc;
        trainTimes(3,index)=toc;
        
        tic; tebag=zbag*trbag; testTimes(1,index)=toc;
        tic; temiles=zmiles*trmiles; testTimes(2,index)=toc;
        tic; tew2=zmiles*trw2; testTimes(3,index)=toc;
        
        
        resRS{index} = tew2;
        resBag{index}=tebag;
        resInst{index} = temiles;
        
        
        aucperf(1,index)=dd_auc(tebag*milroc);
        aucperf(2,index)=dd_auc(temiles*milroc);
        aucperf(3,index)=dd_auc(tew2*milroc);
        
        
        err(1,index) = tebag*testd;
        err(2,index) = temiles*testd;
        err(3,index) = tew2*testd;
        
        
        
        
    end
end


disp(a.name);
mean(err,2)

save(['res_final_' clname '_' num2str(datanr) '.mat'], 'err', 'clasf', 'aucperf', 'resRS', 'resBag', 'resInst', 'trainTimes', 'testTimes');


