function testFinalOriginal(datanr, clasf, clname, saveWeights)


if nargin<4
    saveWeights = 0;
end


%a = reallifemil(datanr);
warning('Loading Musk1, please download other datasets from miproblems.org');
prload('musk1.mat');
a=x; clear x;




[bags labs ids bagids] = getbags(a);
N = length(labs);


Dfname = ['D_bag_miles_' num2str(datanr) '.mat'];
if(exist(Dfname, 'file'))
    load(Dfname);
else
    [Dbag Dmiles] = create_Dmatrices(datanr,1);
    
end


Dbag = prdataset(+Dbag, labs);
Dmiles = prdataset(+Dmiles, labs);
Dbag=setprior(Dbag, 0);
Dmiles = setprior(Dmiles,0);


shuffles=1;
folds=10;


err=nan(3,shuffles*folds);



for j=1:shuffles
    
     
    shuffleddata = milrandomize(a,j);

             
    I=folds;
    for jj=1:folds
        tic
        index=(j-1)*folds+jj
        
    
        
        [x,z,I, itr, ite] = milcrossval(shuffleddata,I); 
        
        %Find indices of the BAGS used (not instances)
        [trl trids] = getbaglabs(x);
        if(ischar(trids)), trids = cellstr(trids); end
        [trids1 bagixtr] = intersect(ids, trids); 
        
        [tel teids] = getbaglabs(z);
         if(ischar(teids)), teids = cellstr(teids); end
        [teids1 bagixte] = intersect(ids, teids); 
        
        xbag = Dbag(bagixtr, bagixtr);
        zbag = Dbag(bagixte, bagixtr);
        
            
        xmiles = Dmiles(bagixtr,itr);
        zmiles = Dmiles(bagixte,itr);
             
        trbag=scalem([],'variance')*clasf;
        trmiles=scalem([],'variance')*clasf;
        trbag = xbag*trbag;
        trmiles=xmiles*trmiles;
        
        dims=size(xmiles,2);
       % if saveWeights ==1
            subspaces  = buildSubspaces(dims, 100, ['fix' num2str(round(dims/5))]);
      %  else
      %      subspaces  = buildSubspaces(dims, 100, ['fix' num2str(round(dims/5))]);
     %   end
        if (saveWeights == 1)
                clweights = nan(10,size(Dmiles,2)); 
        end
        
        %Train the subspaces
        trbags2 = cell(length(subspaces),1);
        for k=1:length(subspaces)
            uclasf2=scalem([],'variance')*featsel(dims,subspaces{k})*clasf*classc;
            trbags2{k} = xmiles*uclasf2;
        
            if (saveWeights == 1)
                
            %itr are indices of instances in the training set    
            %subspaces{k} are indices of subspace, but relative to current training set    
            %itr(subspaces{k}) are absolute indices of instances in subspace  
                
            cl=trbags2{k}.data;         
            %keyboard
            clweights(k,itr(subspaces{k})) = cl{2}.data.rot(:,1); %This is where the weights are stored
           
            
            
            end
            
        end
        
        if(saveWeights==1)
            
            save(['clweights_' num2str(datanr) '_' clname '.mat'], 'clweights');
            return;
        end
     
        
        %Combined classifiers
        w2 = [trbags2{1}];
        
        for k=2:length(subspaces)
            w2 = [w2 trbags2{k}];
        end
                
     
        trw2 = w2*meanc;
                
        tebag=zbag*trbag;
        temiles=zmiles*trmiles;
        tew2=zmiles*trw2;
        
        
        err(1,index)=dd_auc(tebag*milroc);
        err(2,index)=dd_auc(temiles*milroc);
        err(3,index)=dd_auc(tew2*milroc);
        
        

        
       
        
        
    end
end    


disp(a.name);
mean(err,2)

save(['res_final2_disoriginal_' clname '_' num2str(datanr) '.mat'], 'err', 'clasf');

end

