function testSubspaceClassifiers(datanr, clname)


%Get the instance dissimilarity representation (as in MILES)
Dfname = ['D_bag_miles_' num2str(datanr) '.mat'];
if(exist(Dfname, 'file'))
    load(Dfname);
else
    error('Please compute the D matrix first');
    %[Dbag Dmiles] = create_Dmatrices(datanr);
end

%Get the trained classifiers
Dfname = ['train_randsubspace_clasf_' clname '_' num2str(datanr) '.mat'];
Dfname1 = ['train_randsubspace_extra_' clname '_' num2str(datanr) '.mat'];
if(exist(Dfname, 'file') && exist(Dfname1, 'file'))
    load(Dfname);
    load(Dfname1);
else
    error('Please train the classifiers first');
end


resSingleClasf = cell(shuffles*folds);
resSubspaceClasf = cell(shuffles*folds);

errSingleClasf = nan(shuffles*folds);

ensembleSizes = [10 20 50 100];

resCombMean = cell(shuffles*folds,length(subspaceSizes), length(ensembleSizes));
resCombMax = cell(shuffles*folds,length(subspaceSizes), length(ensembleSizes));
resCombProd = cell(shuffles*folds,length(subspaceSizes), length(ensembleSizes));
resCombVote = cell(shuffles*folds,length(subspaceSizes), length(ensembleSizes));


errSub = nan(shuffles*folds,length(subspaceSizes), max(subspaceSizes(length(subspaceSizes))));

errCombMean = nan(shuffles*folds,length(subspaceSizes), length(ensembleSizes));
errCombVote = nan(shuffles*folds,length(subspaceSizes), length(ensembleSizes));
errCombProd = nan(shuffles*folds,length(subspaceSizes), length(ensembleSizes));
errCombMax = nan(shuffles*folds,length(subspaceSizes), length(ensembleSizes));

randreset;
for j=1:shuffles
    
    I=folds;
    for jj=1:folds
        tic
        index=(j-1)*folds+jj;
        
        bagixte = ixtestbags{index};
        itr = ixtraininst{index};
        
        %Get all features test set and classify
        zmiles = Dmiles(bagixte,itr);
        resSingleClasf{index}=zmiles*trainedSingle{index};
        
        try
            errSingleClasf(index) = dd_auc(resSingleClasf{index}*milroc);
        catch
            errSingleClasf(index) = nan;
        end
        
        
        subspaces = ixSubspaces{index};
        
        
        %Get the trained subspaces
        trsub = trainedSubspaces{index};
        
        for s=1:length(subspaceSizes)
            
            for k=1:length(subspaces{s})
                
                %Save ROC curves
                ressub{s,k}=zmiles*trsub{s,k};
                
                try
                    errSub(index,s,k) = dd_auc(ressub{s,k}*milroc);
                catch
                    %In case there are only objects of 1 class we will not
                    %consider this result
                    errSub(index,s,k) = nan;
                end
            end
        end
        resSubspaceClasf{index} = ressub;
        
        
        %Combined classifiers - different subspace sizes
        for s=1:length(subspaceSizes)
            combclasf = [trsub{s,1}*classc];
            
            
            startix = 2;
            endix = ensembleSizes(1);
            
            for e=1:length(ensembleSizes)
                
                
                for k=startix:endix
                    combclasf = [combclasf trsub{s,k}*classc];
                end
                
                combmean = combclasf*meanc;
                resmean=zmiles*combmean;
                resCombMean{index,s,e} = resmean;
                
                combprod = combclasf*prodc;
                resprod=zmiles*combprod;
                resCombProd{index,s,e} = resprod;
                
                
                combmax = combclasf*maxc;
                resmax=zmiles*combmax;
                resCombMax{index,s,e} = resmax;
                
                combvote = combclasf*votec;
                resvote=zmiles*combvote;
                resCombVote{index,s,e} = resvote;
                
                try
                    errCombMean(index,s,e) = dd_auc(resmean*milroc);
                    errCombMax(index,s,e) = dd_auc(resmax*milroc);
                    errCombVote(index,s,e) = dd_auc(resvote*milroc);
                    errCombProd(index,s,e) = dd_auc(resprod*milroc);
                catch
                    errCombMean(index,s,e) = nan;
                    errCombMax(index,s,e) = nan;
                    errCombVote(index,s,e) = nan;
                    errCombProd(index,s,e) = nan;
                    
                end
                
                if e<length(ensembleSizes)
                    startix = ensembleSizes(e)+1;
                    endix = ensembleSizes(e+1);
                end
            end
            
            
            
        end
        
        toc
    end
end



save(['res_randsub_' clname '_' num2str(datanr) '.mat'], 'resCombMean', 'resCombMax', 'resCombVote', 'errCombMean', 'errCombMax',  'errCombVote', 'resCombProd', 'errCombProd', 'errSub', 'resSubspaceClasf', 'resSingleClasf', 'errSingleClasf', 'ensembleSizes');

end

