function trainSubspaceClassifiers(datanr, clasf, clname)

%Load dataset
%a = reallifemil(datanr);
warning('Loading Musk1, please download other datasets from miproblems.org');
prload('musk1.mat');
a=x; clear x;


[bags, labs, ids, bagids] = getbags(a);



%Get the instance dissimilarity representation (as in MILES)
Dfname = ['D_bag_miles_' num2str(datanr) '.mat'];
if(exist(Dfname, 'file'))
    load(Dfname);
else
    [Dbag, Dmiles] = create_Dmatrices(datanr,1);
end

Dmiles = prdataset(+Dmiles, labs);
Dmiles = setprior(Dmiles,0);


%How big are the subspaces going to be?
subspaceSizes = [5 10 25 50 100];

%How many classifiers per ensemble
numClasf = 100;


%How to do cross-validation
shuffles = 1;
folds=10;


%Variables to store everything
ixtrainbags = cell(shuffles*folds,1);
ixtestbags = cell(shuffles*folds,1);
ixtraininst = cell(shuffles*folds,1);

trainedSingle = cell(shuffles*folds,1);
ixSubspaces = cell(shuffles*folds,1);
trainedSubspaces = cell(shuffles*folds,1);


randreset;
for j=1:shuffles
    shuffleddata = milrandomize(a,j);
             
    I=folds;
    for jj=1:folds
        tic
        index=(j-1)*folds+jj
        
        [x,z,I, itr] = milcrossval(shuffleddata,I); 
        
        %Find indices of the BAGS used 
        [~, trids] = getbaglabs(x);
        if(ischar(trids)), trids = cellstr(trids); end
        [~, bagixtr] = intersect(ids, trids); 
        
        [~, teids] = getbaglabs(z);
         if(ischar(teids)), teids = cellstr(teids); end
        [~, bagixte] = intersect(ids, teids); 
        
        
        %Save all necessary indices (for testing)
        ixtrainbags{index} = bagixtr;
        ixtestbags{index} = bagixte;
        ixtraininst{index} = itr;
                
        
        %Training set
        xmiles = Dmiles(bagixtr,itr);
        dims=size(xmiles,2);
                
        %Classifier trained on all features       
        singleClasf = scalem([],'variance')*clasf;
        trainedSingle{index}=xmiles*singleClasf;
        
        
        trsub = cell(length(subspaceSizes), numClasf);
        ixsub = cell(length(subspaceSizes));
        
        for s=1:length(subspaceSizes)
            
            %Define which features go into which subspaces
            subspaces  = buildSubspaces(dims, numClasf, ['fix' num2str(subspaceSizes(s))]);
            ixsub{s} = subspaces;
                    
            %Train subspace clasifiers for different sized subspaces
            for k=1:length(subspaces)
                uclasf2=scalem([],'variance')*featsel(dims,subspaces{k})*clasf; 
                trsub{s,k} = xmiles*uclasf2;
            end
        end
        
        ixSubspaces{index} = ixsub;
        trainedSubspaces{index} = trsub;
        toc
    end
end

%Saving all variables in two parts because of the large file size 
save(['train_randsubspace_extra_' clname '_' num2str(datanr) '.mat'], 'ixSubspaces', 'trainedSingle', 'subspaceSizes', 'shuffles', 'folds', 'clname', 'datanr', 'ixtrainbags', 'ixtestbags', 'ixtraininst','labs', 'numClasf');
save(['train_randsubspace_clasf_' clname '_' num2str(datanr) '.mat'], 'trainedSubspaces', '-v7.3');


end

